SystemOrganization addCategory: #'Mabinogi-Test-Core'!
SystemOrganization addCategory: #'Mabinogi-Test-Utils'!
SystemOrganization addCategory: #'Mabinogi-Test-Persistence'!
SystemOrganization addCategory: #'Mabinogi-Test-Web-Components'!
SystemOrganization addCategory: #'Mabinogi-Test-Commands'!

MbObject subclass: #MbTestingObject
	instanceVariableNames: 'foo requiredField stuff'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Test-Core'!

!MbTestingObject methodsFor: 'accessing' stamp: 'StuartHerring 1/18/2012 21:15'!
fieldWithDifferentLabel
	<label: 'A Different Label'>
	^nil! !

!MbTestingObject methodsFor: 'accessing' stamp: 'StuartHerring 1/18/2012 21:35'!
fieldWithUnknownPragma
	<foobar>
	^nil! !

!MbTestingObject methodsFor: 'accessing' stamp: 'StuartHerring 1/7/2012 13:40'!
foo
	^foo! !

!MbTestingObject methodsFor: 'accessing' stamp: 'StuartHerring 1/7/2012 13:41'!
foo: aFoo
	self set: #foo to: aFoo! !

!MbTestingObject methodsFor: 'accessing' stamp: 'StuartHerring 2/12/2012 19:39'!
ignoredField
	<ignore>
	"Don't include in definition even though it's in accessing"! !

!MbTestingObject methodsFor: 'accessing' stamp: 'StuartHerring 3/3/2012 18:16'!
initialize
	<mbFields: #(fieldWithDifferentLabel fieldWithUnknownPragma foo requiredField stuff)>
	super initialize.
	! !

!MbTestingObject methodsFor: 'private' stamp: 'StuartHerring 5/21/2012 21:01'!
notAField
	"There should be no definition created for this accessor"! !

!MbTestingObject methodsFor: 'accessing' stamp: 'StuartHerring 1/7/2012 14:11'!
requiredField
	<required>
	^requiredField! !

!MbTestingObject methodsFor: 'accessing' stamp: 'StuartHerring 1/7/2012 14:08'!
requiredField: aValue
	self set: #requiredField to: aValue! !

!MbTestingObject methodsFor: 'accessing' stamp: 'StuartHerring 1/28/2012 16:14'!
stuff
	<valueSelector: #stuffValues>
	^stuff! !

!MbTestingObject methodsFor: 'accessing' stamp: 'StuartHerring 1/28/2012 16:13'!
stuff: aValue
	self set: #stuff to: aValue
	! !

!MbTestingObject methodsFor: 'private' stamp: 'StuartHerring 1/29/2012 08:46'!
stuffValues
	^#(one two three)! !

MbTestingObject subclass: #MbTestingSubclassObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Test-Core'!

!MbTestingSubclassObject methodsFor: 'accessing' stamp: 'StuartHerring 5/21/2012 21:01'!
fieldWithDifferentLabel
	<required>
	"Overrides definition in parent class, replacing all options"! !

TestCase subclass: #TestMbCommandProcessor
	instanceVariableNames: 'processor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Test-Commands'!

!TestMbCommandProcessor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:54'!
setUp
	super setUp.
	processor := MbCommandProcessor new.! !

!TestMbCommandProcessor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 21:16'!
testCanUndo
	processor invoke: MbCommand new. 
	processor canUndo should be: true! !

!TestMbCommandProcessor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 21:17'!
testCantUndoBeyondEndOfHistory
	processor invoke: MbCommand new.
	processor undo.
	processor canUndo should be: false! !

!TestMbCommandProcessor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 15:42'!
testCantUndoIfNoEntries
	processor canUndo should be: false! !

!TestMbCommandProcessor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:55'!
testInvokeCommand
	[:command |
		[processor invoke: command ] 
			should strictly satisfy: [ command do]] runScenario ! !

!TestMbCommandProcessor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 21:19'!
testInvokeCommandAddsToHistory
	| command |
	processor invoke: (command := MbCommand new).
	processor history should include: command	! !

!TestMbCommandProcessor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 21:18'!
testUndo
	[:command |
		[processor invoke: command.
		processor undo ] 
			should strictly satisfy: [ command do. command undo]] runScenario ! !

TestCase subclass: #TestMbDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Test-Core'!

!TestMbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:13'!
testCurrencySetsNumericType
	((MbDefinition selector: #foo) currency: $$)
		typeHint should be: #numeric! !

!TestMbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:13'!
testCurrencySetsPrecision
	((MbDefinition selector: #foo) currency: $$) precision
		should be: 2! !

!TestMbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:11'!
testCurrencySymbol
	((MbDefinition selector: #foo) currency: $$)
		currency should equal: $$! !

!TestMbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 20:38'!
testDateAllowsDate
	((MbDefinition selector: #foo) date: true)
		assertValid: Date new! !

!TestMbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/6/2012 21:57'!
testDateRenderHintIsDatePicker
	((MbDefinition selector: #foo) date: true) renderHint
		should be: #datePicker! !

!TestMbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/1/2012 15:40'!
testDateRequiresDate
	[((MbDefinition selector: #foo) date: true)
		assertValid: Object new] should raise: MbInvalidFormatError! !

!TestMbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:48'!
testDateSetsDateTypeHint
	((MbDefinition selector: #foo) date: true) typeHint
		should be: #date! !

!TestMbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2012 16:52'!
testDefaultLabelIsSelector
	self assert: (MbDefinition selector: #multiWordLabel) label equals: 'Multi Word Label'! !

!TestMbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:47'!
testDefaultRenderHintIsNil
	(MbDefinition selector: #foo) renderHint should be: nil! !

!TestMbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:48'!
testDefaultTypeHintIsString
	(MbDefinition selector: #foo) typeHint should be: #string! !

!TestMbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/10/2012 18:35'!
testNotRequiredByDefault
	self deny: (MbDefinition selector: #foo) required! !

!TestMbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:14'!
testNumericSetsNumericType
	((MbDefinition selector: #foo) numeric: true)
		typeHint should be: #numeric! !

!TestMbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:15'!
testNumericWithArgumentSetsPrecision
	((MbDefinition selector: #foo) numeric: 2)
		precision should be: 2! !

!TestMbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:15'!
testNumericWithNoArgumentDoesntSetPrecision
	((MbDefinition selector: #foo) numeric: true)
		precision should be: nil! !

!TestMbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/1/2012 15:24'!
testValidateWith
	[ :model :value | | def |
	def := (MbDefinition selector: #foo).
	def setModel: model.
	def validateWith: #someValidationFunction:. 
	[ def assertValid: value ] should strictly satisfy: [ (model perform: #someValidationFunction: with: value)]	] runScenario! !

!TestMbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:46'!
testValueSelectorSetsRenderHint
	((MbDefinition selector: #foo) valueSelector: #foo) renderHint 
		should be: #dropDown! !

TestCase subclass: #TestMbField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Test-Web-Components'!

TestCase subclass: #TestMbObject
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Test-Core'!

!TestMbObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/7/2012 13:42'!
setUp
	object := MbTestingObject new.! !

!TestMbObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/18/2012 21:50'!
testAccessorsNotInAccessingDontHaveDefinitions
	self assert: (MbTestingObject mbDefinitionFor: #notAField) equals: nil! !

!TestMbObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/18/2012 21:50'!
testDefinitionFor
	self assert: (MbTestingObject mbDefinitionFor: #foo) selector
		equals: #foo! !

!TestMbObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/29/2012 08:17'!
testDefinitions
	self assert: object mbDefinitions size equals: 5! !

!TestMbObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 19:22'!
testDefinitionsAreInherited
	self assert: (MbTestingSubclassObject new mbDefinitions) notEmpty! !

!TestMbObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 19:40'!
testIgnoredSelectorsReturnNilDefinition
	self assert: (MbTestingObject mbDefinitionFor: #ignoredField) isNil! !

!TestMbObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/3/2012 18:17'!
testLabelPragma
	self assert: (MbTestingObject mbDefinitionFor: #fieldWithDifferentLabel) label
	equals: 'A Different Label'! !

!TestMbObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 19:52'!
testOverriddenField
	self assert: (MbTestingSubclassObject mbDefinitionFor: #fieldWithDifferentLabel) required! !

!TestMbObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 19:50'!
testOverriddenFieldsReplaceDefinition
	self assert: (MbTestingSubclassObject mbDefinitionFor: #fieldWithDifferentLabel) label 
		equals: 'Field With Different Label'! !

!TestMbObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/18/2012 21:50'!
testRequiredPragma
	self assert: (MbTestingObject mbDefinitionFor: #requiredField) required
		equals: true! !

!TestMbObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/28/2012 16:16'!
testRestrictedValues
	self should: [ object stuff: #foo] raise: MbValidationError.! !

!TestMbObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/7/2012 14:02'!
testSetRequiredFieldToNullFails
	self should: [ object requiredField: nil ] raise: MbRequiredFieldError! !

!TestMbObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/7/2012 13:45'!
testSimpleSet
	object foo: 'bar'.
	self assert: object foo equals: 'bar'! !

!TestMbObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/18/2012 21:50'!
testUnknownPragma
	self shouldnt: [(MbTestingObject mbDefinitionFor: #fieldWithUnknownPragma) ] raise: MessageNotUnderstood ! !

TestCase subclass: #TestMbRequiredRule
	instanceVariableNames: 'rule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Test-Core'!

!TestMbRequiredRule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 10:06'!
setUp
	rule := MbRequiredRule definition: (MbDefinition new label: 'test').! !

!TestMbRequiredRule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:32'!
testCollectionSucceeds
	[ rule assertValid: #(foo) ] shouldnt raise: MbRequiredFieldError ! !

!TestMbRequiredRule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:32'!
testEmptyCollectionFails
	[ rule assertValid: #() ] should raise: MbRequiredFieldError ! !

!TestMbRequiredRule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:31'!
testEmptyStringFails
	[ rule assertValid: '' ] should raise: MbRequiredFieldError ! !

!TestMbRequiredRule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:31'!
testNilFails
	[ rule assertValid: nil ] should raise: MbRequiredFieldError ! !

!TestMbRequiredRule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:32'!
testObjectSucceeds
	[ rule assertValid: Object new ] shouldnt raise: MbRequiredFieldError ! !

!TestMbRequiredRule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:32'!
testStringSucceeds
	[ rule assertValid: 'foo' ] shouldnt raise: MbRequiredFieldError ! !

TestCase subclass: #TestMbSimpleCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Test-Commands'!

!TestMbSimpleCommand methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/21/2012 20:53'!
bar
	"Exists so that code critics don't complain"! !

!TestMbSimpleCommand methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/21/2012 20:53'!
baz
	"Exists so that code critics don't complain"! !

!TestMbSimpleCommand methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:41'!
testDoBlock
	[ :foo |
		[(MbSimpleCommand do: [ foo bar ]) do ] should strictly satisfy: [foo bar]] runScenario! !

!TestMbSimpleCommand methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:42'!
testUndoBlock
	[ :foo |
		[(MbSimpleCommand do: [ foo bar ] undo: [foo baz]) undo ] should strictly satisfy: [foo baz]] runScenario! !

TestCase subclass: #TestMbTransactionalCommandProcessor
	instanceVariableNames: 'command failedCommand'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Test-Persistence'!

!TestMbTransactionalCommandProcessor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/4/2012 14:10'!
setUp
	command := MbSimpleCommand do: [] undo: [].
	failedCommand := MbSimpleCommand do: [ Error signal ] undo: [ Error signal]! !

!TestMbTransactionalCommandProcessor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/5/2012 16:54'!
testInvokeCallsCommit
	[ :t | 
		[(MbTransactionalCommandProcessor transactionProvider: t) invoke: command ]
			should strictly satisfy: [ t commit: (Instance of: BlockClosure) ]] runScenario! !

!TestMbTransactionalCommandProcessor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/5/2012 17:09'!
testUndoCallsCommit
	[ :t | 
		[(MbTransactionalCommandProcessor transactionProvider: t) undo ]
			should strictly satisfy: [ t commit: (Instance of: BlockClosure) ]] runScenario! !

Object subclass: #MbMocketryMessages
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Test-Utils'!

!MbMocketryMessages commentStamp: 'StuartHerring 5/21/2012 20:48' prior: 0!
This class only exists so that the messages sent by Mocketry can exist in the system.  That way code critics will stop giving false positives for them!

!MbMocketryMessages methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/21/2012 20:50'!
be: arg! !

!MbMocketryMessages methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/21/2012 20:52'!
equal: arg! !

!MbMocketryMessages methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/21/2012 20:51'!
raise: arg! !

!MbMocketryMessages methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/21/2012 20:50'!
strictly! !
